package it.unitn.disi.ronchet.esercitazione6;

import javafx.scene.layout.HBox;
import javafx.scene.paint.Color;
import javafx.scene.shape.Circle;
import javafx.scene.shape.Polygon;
import javafx.scene.shape.Rectangle;
import javafx.scene.shape.Shape;

import java.util.Random;

public class Figura extends HBox {
    ClickListener listener=null;
    final static Random generator=new Random();
    private Shape shape=null;
    private int ix;
    private int iy;
    private boolean isColored=false;
    private Color color=null;

    Figura(int i, int j, ClickListener listener) {
        ix=i;
        iy=j;
        switch (generator.nextInt(3)) {
            case 0: shape=new Rectangle(50,50);
                break;
            case 1: shape=new Polygon(0.,0.,50,0,25,45);;
                break;
            case 2: shape=new Circle(25);
                break;
        }
        if ((ix+iy)%2==0) {
            color=Color.RED;
        } else {
            color= Color.GREEN;
        }
        setWhite();
        this.getChildren().add(shape);
        this.setOnMouseClicked(listener);
    }


    public void swapColor(){
        if (isColored) {
            setWhite();
        } else {
            setColored();
        }
    }

    public void setColored(){
        shape.setFill(color);
        shape.setStroke(Color.BLACK);
        isColored=true;
    }
    public void setWhite(){
        shape.setFill(Color.WHITE);
        shape.setStroke(Color.BLACK);
        isColored=false;
    }
    @Override
    public String toString() {return ix+" "+iy;}
}
