package it.unitn.disi.ronchet.esercitazione6;

import javafx.application.Application;
import javafx.event.EventHandler;
import javafx.fxml.FXMLLoader;
import javafx.scene.Scene;
import javafx.scene.input.MouseEvent;
import javafx.scene.layout.Background;
import javafx.scene.layout.BorderPane;
import javafx.scene.layout.GridPane;
import javafx.scene.paint.Color;
import javafx.stage.Stage;

import java.io.IOException;


public class HelloApplication extends Application {
    @Override
    public void start(Stage stage) throws IOException {
        GridPane gp = new GridPane();
        ClickListener listener=new ClickListener();
        for (int i = 1; i <= 8; i++) {
            for (int j = 1; j <= 8; j++) {
                Figura f = new Figura(i, j,listener);
                gp.add(f, i, j);
            }
        }
        KeyController controller=new KeyController(gp);
        KeyListener keyListener=new KeyListener(controller);
        Scene scene = new Scene(gp, 425, 410);
        scene.setOnKeyTyped(keyListener);
        scene.setFill(Color.YELLOW);
        stage.setTitle("Esercitazione 6");
        stage.setScene(scene);
        stage.show();
    }

    private BorderPane setupGraphics() {
        BorderPane bp = new BorderPane();

        return bp;
    }

    public static void main(String[] args) {
        launch();
    }
}