package it.unitn.disi.ronchet.esercitazione6;

import javafx.collections.ObservableList;
import javafx.scene.Node;
import javafx.scene.layout.GridPane;

import java.util.List;

public class KeyController {
    String firstKey = null;
    GridPane gp = null;

    KeyController(GridPane gp) {
        this.gp = gp;
    }

    public void respondTo(String key) {
        System.out.println(key);
        if (key.equals("c")) {
            firstKey = null;
    } else if(key.equals("r")) {
            firstKey = null;
            List<Node> children = gp.getChildren();
            for (Node x : children) {
                if (x instanceof Figura) {
                    ((Figura) x).setWhite();
                }
            }
        }else {
            if (firstKey == null) firstKey = key;
            else {
                System.out.println(firstKey+" "+key);
                Figura f = (Figura) getElementAt(gp, Integer.parseInt(firstKey), Integer.parseInt(key));
                f.swapColor();
                firstKey=null;
            }
        }

    }

    /**
     * implementazione	generale	del	metodo	per	trovare	quale	elementi	si	trovi
     * in	posizione	i,j	in	un	GridPane.
     *
     * @param gp il	GridPane in	cui	cercare
     * @param j  colonna
     * @param i  riga
     * @return l'elemento	trovato
     */
    Node getElementAt(GridPane gp, int i, int j) {
        for (Node x : gp.getChildren()) {
            if ((GridPane.getRowIndex(x) == i) &&
                    (GridPane.getColumnIndex(x) == j)) {
                return x;
            }
        }
        return null;
    }
}

